

`default_nettype none

module multiplier #(parameter L_BITS = 4) (
	input   wire                                   	clk,
	input 	wire[31:0]								offset,
	input 	wire[L_BITS-1:0]						level,
	output	reg [32+L_BITS-1:0]						result
);

always @(posedge clk) begin
	result <= offset * level;
end

endmodule





`default_nettype wire



