
`default_nettype none


module one_hot_to_binary #(parameter OFFSET = 0) 
(
	input   wire                                   	clk,
	input 	wire									rst_n,
	input 	wire									um_done,
	input 	wire									um_activated,
	input 	wire[31:0]								one_hot,
	output  reg[8:0]								binary,
	output  reg										valid
);

reg [31:0] 	debug_one_hot;


always @(posedge clk)
begin
	if (~rst_n | um_done | ~um_activated) begin
		binary <= 0;
		debug_one_hot <= 0;
		valid<= 0;
	end
	else begin
		binary <= 0;

		
		if( one_hot[0] ) begin
			binary <= 31 + OFFSET;
		end
		else if( one_hot[1] ) begin
			binary <= 30 + OFFSET;
		end
		else if( one_hot[2] ) begin
			binary <= 29 + OFFSET;
		end
		else if( one_hot[3] ) begin
			binary <= 28 + OFFSET;
		end
		else if( one_hot[4] ) begin
			binary <= 27 + OFFSET;
		end
		else if( one_hot[5] ) begin
			binary <= 26 + OFFSET;
		end
		else if( one_hot[6] ) begin
			binary <= 25 + OFFSET;
		end
		else if( one_hot[7] ) begin
			binary <= 24 + OFFSET;
		end
		else if( one_hot[8] ) begin
			binary <= 23 + OFFSET;
		end
		else if( one_hot[9] ) begin
			binary <= 22 + OFFSET;
		end
		else if( one_hot[10] ) begin
			binary <= 21 + OFFSET;
		end
		else if( one_hot[11] ) begin
			binary <= 20 + OFFSET;
		end
		else if( one_hot[12] ) begin
			binary <= 19 + OFFSET;
		end
		else if( one_hot[13] ) begin
			binary <= 18 + OFFSET;
		end
		else if( one_hot[14] ) begin
			binary <= 17 + OFFSET;
		end
		else if( one_hot[15] ) begin
			binary <= 16 + OFFSET;
		end
		else if( one_hot[16] ) begin
			binary <= 15 + OFFSET;
		end
		else if( one_hot[17] ) begin
			binary <= 14 + OFFSET;
		end
		else if( one_hot[18] ) begin
			binary <= 13 + OFFSET;
		end
		else if( one_hot[19] ) begin
			binary <= 12 + OFFSET;
		end
		else if( one_hot[20] ) begin
			binary <= 11 + OFFSET;
		end
		else if( one_hot[21] ) begin
			binary <= 10 + OFFSET;
		end
		else if( one_hot[22] ) begin
			binary <= 9 + OFFSET;
		end
		else if( one_hot[23] ) begin
			binary <= 8 + OFFSET;
		end
		else if( one_hot[24] ) begin
			binary <= 7 + OFFSET;
		end
		else if( one_hot[25] ) begin
			binary <= 6 + OFFSET;
		end
		else if( one_hot[26] ) begin
			binary <= 5 + OFFSET;
		end
		else if( one_hot[27] ) begin
			binary <= 4 + OFFSET;
		end
		else if( one_hot[28] ) begin
			binary <= 3 + OFFSET;
		end
		else if( one_hot[29] ) begin
			binary <= 2 + OFFSET;
		end
		else if( one_hot[30] ) begin
			binary <= 1 + OFFSET;
		end
		else if( one_hot[31] ) begin
			binary <= OFFSET;
		end
		else begin
			binary <= 0;
		end

		if( one_hot ) begin
			valid <= 1;
		end
		else begin
			valid <= 0;
		end

		debug_one_hot <= one_hot;
	end
end


endmodule



`default_nettype wire
