`include "framework_defines.vh"

`ifndef AFU_DEFINES_VH
`define AFU_DEFINES_VH

`define REGEX_AFU               16'h1
`define MURMUR_AFU              16'h2
`define TEST_AND_COUNT_AFU      16'h3
`define MAX_MIN_SUM_AFU         16'h4
`define COPY_AFU                16'h5
`define PERCENTAGE_AFU          16'h6
`define MAC_AFU                 16'h7
`define SELECTION               16'h8
`define SKYLINE_AFU             16'h9
`define SGD_AFU                 16'ha
`define PARTITIONER_AFU         16'hb
`define DT_AFU                  16'hc
`define LEVENSHTEINDISTANCE_AFU 16'hd
`define KMEANS_AFU		16'he
`define MICROBENCH_AFU 16'h16


`define UNDEF_AFU             16'hffff


`define FTHREAD_1_PLACED_AFU        `MICROBENCH_AFU
`define FTHREAD_2_PLACED_AFU        `COPY_AFU
`define FTHREAD_3_PLACED_AFU        `COPY_AFU
`define FTHREAD_4_PLACED_AFU        `COPY_AFU
`define FTHREAD_5_PLACED_AFU        `COPY_AFU
`define FTHREAD_6_PLACED_AFU        `COPY_AFU
`define FTHREAD_7_PLACED_AFU        `COPY_AFU
`define FTHREAD_8_PLACED_AFU        `COPY_AFU

`define FTHREAD_1_AFU_CONFIG_LINES  1
`define FTHREAD_2_AFU_CONFIG_LINES  1
`define FTHREAD_3_AFU_CONFIG_LINES  1
`define FTHREAD_4_AFU_CONFIG_LINES  1
`define FTHREAD_5_AFU_CONFIG_LINES  1
`define FTHREAD_6_AFU_CONFIG_LINES  1
`define FTHREAD_7_AFU_CONFIG_LINES  1
`define FTHREAD_8_AFU_CONFIG_LINES  1

`define FTHREAD_1_USER_AFU_RD_TAG 	`AFU_TAG
`define FTHREAD_2_USER_AFU_RD_TAG 	`AFU_TAG
`define FTHREAD_3_USER_AFU_RD_TAG 	`AFU_TAG
`define FTHREAD_4_USER_AFU_RD_TAG 	42
`define FTHREAD_5_USER_AFU_RD_TAG 	`AFU_TAG
`define FTHREAD_6_USER_AFU_RD_TAG 	`AFU_TAG
`define FTHREAD_7_USER_AFU_RD_TAG 	`AFU_TAG
`define FTHREAD_8_USER_AFU_RD_TAG 	`AFU_TAG

`define FTHREAD_1_USER_AFU_WR_TAG 	`AFU_TAG
`define FTHREAD_2_USER_AFU_WR_TAG 	`AFU_TAG
`define FTHREAD_3_USER_AFU_WR_TAG 	`AFU_TAG
`define FTHREAD_4_USER_AFU_WR_TAG 	42
`define FTHREAD_5_USER_AFU_WR_TAG 	`AFU_TAG
`define FTHREAD_6_USER_AFU_WR_TAG 	`AFU_TAG
`define FTHREAD_7_USER_AFU_WR_TAG 	`AFU_TAG
`define FTHREAD_8_USER_AFU_WR_TAG 	`AFU_TAG

`define FTHREAD_1_AFU_USE_ORDERING 	1
`define FTHREAD_2_AFU_USE_ORDERING 	1
`define FTHREAD_3_AFU_USE_ORDERING 	1
`define FTHREAD_4_AFU_USE_ORDERING 	0
`define FTHREAD_5_AFU_USE_ORDERING 	1
`define FTHREAD_6_AFU_USE_ORDERING 	1
`define FTHREAD_7_AFU_USE_ORDERING 	1
`define FTHREAD_8_AFU_USE_ORDERING 	1

`define FTHREAD_1_PLACED_AFU_CLK    200
`define FTHREAD_2_PLACED_AFU_CLK    200
`define FTHREAD_3_PLACED_AFU_CLK    `BASE_CLK
`define FTHREAD_4_PLACED_AFU_CLK    200
`define FTHREAD_5_PLACED_AFU_CLK    `BASE_CLK
`define FTHREAD_6_PLACED_AFU_CLK    `BASE_CLK
`define FTHREAD_7_PLACED_AFU_CLK    `BASE_CLK
`define FTHREAD_8_PLACED_AFU_CLK    `BASE_CLK


`define NUM_JOB_TYPES               1
`define JOB_TYPE_BITS               1

`endif
