
#ifndef __MWM_LEMON_SOLVER_HPP__
#define __MWM_LEMON_SOLVER_HPP__

#include "mwmsolver.hpp"

#include <lemon/list_graph.h>
#include <lemon/concepts/graph.h>
#include <lemon/core.h>
#include <lemon/matching.h>
#include <iostream>
#include <lemon/list_graph.h>
#include <bitset>

#include <vector>


class MWMLemon :public MWMSolver
{
public:
    void* solve(void*  pinput, Timing* timer, RunParams* rp);

    std::string get_solver_name();

    double get_guarantee(RunParams* rp);
};

#endif
